package dev.shadowsoffire.apotheosis.adventure.socket;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.socket.ReactiveSmithingRecipe;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketedGems;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import net.minecraft.core.RegistryAccess;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.Container;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.Block;

public class WithdrawalRecipe extends AdventureModule.ApothSmithingRecipe implements ReactiveSmithingRecipe {
  private static final ResourceLocation ID = new ResourceLocation("apotheosis:widthdrawal");
  
  public WithdrawalRecipe() {
    super(ID, Ingredient.f_43901_, Ingredient.m_43929_(new ItemLike[] { (ItemLike)Adventure.Items.SIGIL_OF_WITHDRAWAL.get() }, ), ItemStack.f_41583_);
  }
  
  public boolean m_5818_(Container pInv, Level pLevel) {
    ItemStack base = pInv.m_8020_(1);
    ItemStack sigils = pInv.m_8020_(2);
    return (base.m_41613_() == 1 && sigils.m_41720_() == Adventure.Items.SIGIL_OF_WITHDRAWAL.get() && SocketHelper.getGems(base).stream().anyMatch(GemInstance::isValid));
  }
  
  public ItemStack m_5874_(Container pInv, RegistryAccess regs) {
    ItemStack out = pInv.m_8020_(1).m_41777_();
    if (out.m_41619_())
      return ItemStack.f_41583_; 
    SocketHelper.setGems(out, SocketedGems.EMPTY);
    return out;
  }
  
  public void onCraft(Container inv, Player player, ItemStack output) {
    ItemStack base = inv.m_8020_(1);
    SocketedGems gems = SocketHelper.getGems(base);
    for (int i = 0; i < gems.size(); i++) {
      ItemStack stack = gems.get(i).gemStack();
      if (!stack.m_41619_()) {
        stack.m_41749_("uuids");
        if (!player.m_36356_(stack))
          Block.m_49840_(player.m_9236_(), player.m_20183_(), stack); 
      } 
    } 
    SocketHelper.setGems(base, SocketedGems.EMPTY);
  }
  
  public RecipeSerializer<?> m_7707_() {
    return (RecipeSerializer<?>)Serializer.INSTANCE;
  }
  
  public RecipeType<?> m_6671_() {
    return RecipeType.f_44113_;
  }
  
  public boolean m_5598_() {
    return true;
  }
}
